<template>
  <rect
    v-if="range !== null"
    class="canvas-cursor"
    :x="is3d ? position.x - 2 : range.start - 2"
    :width="range.width"
    :y="y"
    :height="is3d ? height : '20px'"
    z-index="-1"
  />
</template>
<script lang="ts">
import {
  Component, Prop, Watch,
} from 'vue-property-decorator';
import type {
  Unit, Onset, Pixel, Range, Signature, Duration, Point,
} from '@/data';
import type { Image3DPageData } from '@/data/Source';
import type { DeMuxPixel } from '@/data/PixelUtils';
import PixelUtils from '@/data/PixelUtils';
import LabelBehavior from '../LabelBehavior.vue';
import type { BCursorMoveEmitter } from './BCanvasCursor.vue';

@Component
export default class BCanvasMeasureCursor extends LabelBehavior<BCursorMoveEmitter> {
  @Prop({ required: true })
  musicalTime!: Onset | null;

  @Prop({ required: true })
  signature!: Signature;

  @Prop({ required: true })
  pixelUnit!: Unit<Pixel>;

  @Prop()
  pages!: Array<Image3DPageData>;

  @Prop({ default: false, type: Boolean })
  is3d!: boolean;

  range: Range<Pixel> | null = null;

  height: Pixel = 20 as Pixel;

  y = 0;

  position: DeMuxPixel | null = null;

  @Watch('musicalTime')
  @Watch('pixelUnit')
  onTimeChange() {
    const oldPosition = this.range?.start;

    this.range = this.calculatePosition();
    this.position = PixelUtils.deMux(this.range?.start || 0 as Pixel);
    const end = PixelUtils.deMux(this.range?.end || 0 as Pixel);

    if (this.position.row !== end.row) {
      this.position.x = this.pages[end.page].rows[end.row].start;
      if (this.range) {
        this.range.width = PixelUtils
          .deMux(this.range?.end || 0 as Pixel).x - this.position.x as Pixel;
      }
    }

    const currentRowY = this.pages[end?.page || 0].rows[end?.row || 0].y;
    const currentPageY = this.pages[end?.page || 0].height * (end?.page || 0);
    this.y = currentPageY + currentRowY;
    this.height = this.pages[end?.page || 0].rows[end?.row || 0].height;

    if (this.canEmitOrRegister
      && this.range !== null
      && this.range.start !== oldPosition) {
      this.emit(
        'cursor-move',
        { x: PixelUtils.deMux(this.range.start).x, y: this.y } as Point,
      );
    }
  }

  calculatePosition(): Range<Pixel> | null {
    // If not musical time, don't display anything
    if (this.musicalTime === null) return null;

    const measure = this.signature.getMeasureFromOnset(this.musicalTime);
    const onset = this.signature.getOnsetFromMeasure(measure);
    const duration = this.signature
      .getOnsetFromMeasure(measure + 1) - onset as Duration;

    return this.pixelUnit.fromInterval(onset, duration);
  }
}
</script>
<style scoped lang="scss">
.canvas-cursor {
  border: 2px solid black;
  opacity: 0.1;
}
</style>
